searchData={"items":[{"type":"module","title":"Membrane.RTC.Engine.Support.StaticTrackSender","doc":"This is a very simple version of\n`Membrane.RTC.Engine.Endpoint.WebRTC.TrackSender` element.\n\nEngine forwards track starting from a keyframe.\nTherefore, whenever some endpoint requests some\ntrack, engine sends keyframe request to the track\nsource.\n\nIn case of publishing from a file we are not able to\ngenerate keyframe on request. This element ignores\nincoming demands and starts sending data after receiving\nfirst keyframe request. Subsequent keyframe requests\nare ignored.","ref":"Membrane.RTC.Engine.Support.StaticTrackSender.html"},{"type":"module","title":"Element options - Membrane.RTC.Engine.Support.StaticTrackSender","doc":"Passed via struct `t:Membrane.RTC.Engine.Support.StaticTrackSender.t/0`\n\n- `track`  \n\n  ```\n  Membrane.RTC.Engine.Track.t()\n  ```\n  \n  ***Required***  \n  Track this sender will maintain\n\n\n- `is_keyframe`  \n\n  ```\n  (Membrane.Buffer.t(), Track.t() -> boolean())\n  ```\n  \n  ***Required***  \n  Function informing if buffer is a keyframe for this track","ref":"Membrane.RTC.Engine.Support.StaticTrackSender.html#module-element-options"},{"type":"module","title":"Pads - Membrane.RTC.Engine.Support.StaticTrackSender","doc":"### `:input`\n\nAccepted formats:\n```\nMembrane.RTP\n```\n\nDirection: | `:input`\nAvailability: | `:always`\nFlow control: | `:manual`\nDemand unit: | `:buffers`\n\n\n### `:output`\n\nAccepted formats:\n```\nMembrane.RTP\n```\n\nDirection: | `:output`\nAvailability: | `:always`\nFlow control: | `:manual`\nDemand unit: | `nil`","ref":"Membrane.RTC.Engine.Support.StaticTrackSender.html#module-pads"},{"type":"function","title":"Membrane.RTC.Engine.Support.StaticTrackSender.options/0","doc":"Returns description of options available for this module","ref":"Membrane.RTC.Engine.Support.StaticTrackSender.html#options/0"},{"type":"type","title":"Membrane.RTC.Engine.Support.StaticTrackSender.t/0","doc":"Struct containing options for `Membrane.RTC.Engine.Support.StaticTrackSender`","ref":"Membrane.RTC.Engine.Support.StaticTrackSender.html#t:t/0"},{"type":"module","title":"Membrane.RTC.Engine","doc":"RTC Engine implementation.\n\nRTC Engine is an abstraction layer responsible for linking together different types of Endpoints.\nFrom the implementation point of view, RTC Engine is a `Membrane.Pipeline`.","ref":"Membrane.RTC.Engine.html"},{"type":"module","title":"Messages - Membrane.RTC.Engine","doc":"The RTC Engine works by sending messages which notify user logic about important events.\nTo receive RTC Engine messages you have to register your process so that RTC Engine will\nknow where to send them.\nAll messages RTC Engine can emit are described in `Membrane.RTC.Engine.Message` docs.\n\n#","ref":"Membrane.RTC.Engine.html#module-messages"},{"type":"module","title":"Registering for messages - Membrane.RTC.Engine","doc":"Registration can be done using `register/2` e.g.\n\n```elixir\nEngine.register(rtc_engine, self())\n```\n\nThis will register your process to receive RTC Engine messages.\nYou can register multiple processes to receive messages from an RTC Engine instance.\nIn such a case each message will be sent to each registered process.","ref":"Membrane.RTC.Engine.html#module-registering-for-messages"},{"type":"module","title":"Endpoints - Membrane.RTC.Engine","doc":"Endpoints are `Membrane.Bin`s able to publish their own tracks and subscribe to tracks from other Endpoints.\nOne can think about Endpoint as an entity responsible for handling some specific task.\nAn Endpoint can be added and removed using `add_endpoint/3` and `remove_endpoint/2` respectively.\n\nThere are two types of Endpoints:\n* Standalone Endpoints - they are in most cases spawned only once per RTC Engine instance and they are not associated with any client.\n* Client Endpoints - they are associated with some client.\nAssociating Endpoint with client will send some Media Events to the Endpoint's Client Library\ne.g. one which indicates which tracks belong to which client.\n\nCurrently RTC Engine ships with the implementation of the following Endpoints:\n* `Membrane.RTC.Engine.Endpoint.WebRTC` which is responsible for establishing a connection with some WebRTC\nclient (mainly browser) and exchanging media with it. WebRTC Endpoint is a Client Endpoint.\n* `Membrane.RTC.Engine.Endpoint.HLS` which is responsible for receiving media tracks from all other Endpoints and\nsaving them to files by creating HLS playlists. HLS Endpoint is a Standalone Endpoint.\n* `Membrane.RTC.Engine.Endpoint.RTSP` which is responsible for connecting to a remote RTSP stream source and\nsending the appropriate media track to other Endpoints. RTSP Endpoint is a Standalone Endpoint.\n* `Membrane.RTC.Engine.Endpoint.File` which is responsible for reading track from a file, payloading it into RTP, and\nsending it to other Endpoints. File Endpoint is a Standalone Endpoint.\n\nEach of these endpoints is available as a separate package. Refer to the appropriate package for usage examples:\n* [`membrane_rtc_engine_webrtc`](https://hexdocs.pm/membrane_rtc_engine_webrtc/readme.html)\n* [`membrane_rtc_engine_hls`](https://hexdocs.pm/membrane_rtc_engine_hls/readme.html)\n* [`membrane_rtc_engine_rtsp`](https://hexdocs.pm/membrane_rtc_engine_rtsp/readme.html)\n* [`membrane_rtc_engine_file`](https://hexdocs.pm/membrane_rtc_engine_file/readme.html)\n\nUser can also implement custom Endpoints, see Custom Endpoints guide.\n\n#","ref":"Membrane.RTC.Engine.html#module-endpoints"},{"type":"module","title":"Readiness state - Membrane.RTC.Engine","doc":"Each endpoint is presumed to be initially inactive and has to declare itself ready to fully join the Engine.\n\nBefore it does, it:\n* will not receive notifications about other endpoints and their metadata\n* will not receive information about tracks\n* will not be able to publish any tracks\n* will not be able to update their metadata\n\nWhen declaring itself as ready, the endpoint also has an opportunity to set their metadata.\nTo mark the endpoint as active, it has to send the `t:ready_action_t/0`.\n\n**Example**\n```elixir\n@impl true\ndef handle_other({:media_event, %{type: \"join\", metadata: metadata}}, _context, state) do\n  {{:ok, notify: {:ready, metadata}}, state}\nend\n\n@impl true\ndef handle_other(:ready, _context, state) do\n  Membrane.Logger.debug(\"Succesfully activated the endpoint\")\n  {:ok, state}\nend\n```","ref":"Membrane.RTC.Engine.html#module-readiness-state"},{"type":"function","title":"Membrane.RTC.Engine.add_endpoint/3","doc":"Adds endpoint to the RTC Engine\n\nFor more information refer to `t:endpoint_options_t/0`.","ref":"Membrane.RTC.Engine.html#add_endpoint/3"},{"type":"function","title":"Membrane.RTC.Engine.child_spec/1","doc":"Returns child specification for spawning under a supervisor","ref":"Membrane.RTC.Engine.html#child_spec/1"},{"type":"function","title":"Membrane.RTC.Engine.get_endpoints/1","doc":"Returns list of the RTC Engine's endpoints.","ref":"Membrane.RTC.Engine.html#get_endpoints/1"},{"type":"function","title":"Membrane.RTC.Engine.get_num_forwarded_tracks/1","doc":"Returns number of forwarded tracks in RTC Engine.\n\nIt is number of active and pending subscriptions.","ref":"Membrane.RTC.Engine.html#get_num_forwarded_tracks/1"},{"type":"function","title":"Membrane.RTC.Engine.get_registry_name/0","doc":"","ref":"Membrane.RTC.Engine.html#get_registry_name/0"},{"type":"function","title":"Membrane.RTC.Engine.get_tracks/1","doc":"Returns list of the RTC Engine's tracks.","ref":"Membrane.RTC.Engine.html#get_tracks/1"},{"type":"function","title":"Membrane.RTC.Engine.message_endpoint/3","doc":"Sends message to RTC Engine endpoint.\nIf endpoint doesn't exist message is ignored","ref":"Membrane.RTC.Engine.html#message_endpoint/3"},{"type":"function","title":"Membrane.RTC.Engine.register/2","doc":"Registers process with pid `who` for receiving messages from RTC Engine","ref":"Membrane.RTC.Engine.html#register/2"},{"type":"function","title":"Membrane.RTC.Engine.remove_endpoint/2","doc":"Removes endpoint from the RTC Engine","ref":"Membrane.RTC.Engine.html#remove_endpoint/2"},{"type":"function","title":"Membrane.RTC.Engine.start/2","doc":"","ref":"Membrane.RTC.Engine.html#start/2"},{"type":"function","title":"Membrane.RTC.Engine.start_link/2","doc":"","ref":"Membrane.RTC.Engine.html#start_link/2"},{"type":"function","title":"Membrane.RTC.Engine.subscribe/4","doc":"Subscribes an endpoint for a track.\n\nThe endpoint will be notified about track readiness in `c:Membrane.Bin.handle_pad_added/3` callback.\n`endpoint_id` is the id of the endpoint, which wants to subscribe to the track.","ref":"Membrane.RTC.Engine.html#subscribe/4"},{"type":"function","title":"Membrane.RTC.Engine.terminate/2","doc":"Terminates the engine.\n\nAccepts three options:\n  * `asynchronous?` - if set to `true`, pipline termination won't be blocking and\n    will be executed in the process, which pid is returned as function result. If\n    set to `false`, engine termination will be blocking and will be executed in\n    the process that called this function. Defaults to `false`.\n  * `timeout` - tells how much time (ms) to wait for engine to get gracefully\n    terminated. Defaults to 5000.\n  * `force?` - if set to `true` and engine is still alive after `timeout`,\n    engine will be killed using `Process.exit/2` with reason `:kill`, and function\n    will return `{:error, :timeout}`. If set to `false` and engine is still alive\n    after `timeout`, function will raise an error. Defaults to `false`.\n\nReturns:\n  * `{:ok, pid}` - if option `asynchronous?: true` was passed.\n  * `:ok` - if engine was gracefully terminated within `timeout`.\n  * `{:error, :timeout}` - if engine was killed after a `timeout`.","ref":"Membrane.RTC.Engine.html#terminate/2"},{"type":"function","title":"Membrane.RTC.Engine.unregister/2","doc":"Unregisters process with pid `who` from receiving messages from RTC Engine","ref":"Membrane.RTC.Engine.html#unregister/2"},{"type":"type","title":"Membrane.RTC.Engine.endpoint_options_t/0","doc":"Endpoint configuration options.\n\n* `id` - assigned endpoint id. If not provided it will be generated by RTC Engine.\n* `node` - node on which endpoint should be spawned. If not provided, current node is used.","ref":"Membrane.RTC.Engine.html#t:endpoint_options_t/0"},{"type":"type","title":"Membrane.RTC.Engine.forward_to_parent_action_t/0","doc":"Membrane action that will cause RTC Engine to forward supplied message to the business logic.","ref":"Membrane.RTC.Engine.html#t:forward_to_parent_action_t/0"},{"type":"type","title":"Membrane.RTC.Engine.options_t/0","doc":"RTC Engine configuration options.\n\n* `id` is used by logger. If not provided it will be generated.\n* `trace_ctx` is used by OpenTelemetry. All traces from this engine will be attached to this context.\nExample function from which you can get Otel Context is `get_current/0` from `OpenTelemetry.Ctx`.\n* `display_manager?` - set to `true` if you want to limit number of tracks sent from `Membrane.RTC.Engine.Endpoint.WebRTC` to a browser.\n* `toilet_capacity` - sets capacity of buffer between engine and endpoints. Use it when you expect bursts of data for your tracks. If not provided it will be set to 200.","ref":"Membrane.RTC.Engine.html#t:options_t/0"},{"type":"type","title":"Membrane.RTC.Engine.publish_action_t/0","doc":"Membrane action that will cause RTC Engine to publish some message to all other endpoints.","ref":"Membrane.RTC.Engine.html#t:publish_action_t/0"},{"type":"type","title":"Membrane.RTC.Engine.publish_message_t/0","doc":"Types of messages that can be published to other Endpoints.","ref":"Membrane.RTC.Engine.html#t:publish_message_t/0"},{"type":"type","title":"Membrane.RTC.Engine.published_message_t/0","doc":"Type of messages that need to be handled by each endpoint.","ref":"Membrane.RTC.Engine.html#t:published_message_t/0"},{"type":"type","title":"Membrane.RTC.Engine.ready_ack_msg_t/0","doc":"A message that the Engine sends to the endpoint when it ackowledges its `t:ready_action_t/0`","ref":"Membrane.RTC.Engine.html#t:ready_ack_msg_t/0"},{"type":"type","title":"Membrane.RTC.Engine.ready_action_t/0","doc":"Membrane action that will mark the endpoint as ready and set its metadata.\nThe Engine will respond with `t:ready_ack_msg_t/0` to acknowledge your transition to ready state.\n\nThis action can only be used once, any further calls by an endpoint will be ignored.","ref":"Membrane.RTC.Engine.html#t:ready_action_t/0"},{"type":"type","title":"Membrane.RTC.Engine.subscription_opts_t/0","doc":"Subscription options.","ref":"Membrane.RTC.Engine.html#t:subscription_opts_t/0"},{"type":"type","title":"Membrane.RTC.Engine.track_ready_action_t/0","doc":"Membrane action that will inform RTC Engine about track readiness.","ref":"Membrane.RTC.Engine.html#t:track_ready_action_t/0"},{"type":"module","title":"Membrane.RTC.Engine.Endpoint","doc":"Module representing RTC Engine's endpoint.\n\nFor specific information about possible endpoints, refer to the documentation of `Membrane.RTC.Engine`.","ref":"Membrane.RTC.Engine.Endpoint.html"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.get_active_track_metadata/1","doc":"","ref":"Membrane.RTC.Engine.Endpoint.html#get_active_track_metadata/1"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.get_active_tracks/1","doc":"","ref":"Membrane.RTC.Engine.Endpoint.html#get_active_tracks/1"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.get_audio_tracks/1","doc":"","ref":"Membrane.RTC.Engine.Endpoint.html#get_audio_tracks/1"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.get_track_by_id/2","doc":"","ref":"Membrane.RTC.Engine.Endpoint.html#get_track_by_id/2"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.get_tracks/1","doc":"","ref":"Membrane.RTC.Engine.Endpoint.html#get_tracks/1"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.get_video_tracks/1","doc":"","ref":"Membrane.RTC.Engine.Endpoint.html#get_video_tracks/1"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.new/3","doc":"","ref":"Membrane.RTC.Engine.Endpoint.html#new/3"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.update_track_encoding/3","doc":"","ref":"Membrane.RTC.Engine.Endpoint.html#update_track_encoding/3"},{"type":"function","title":"Membrane.RTC.Engine.Endpoint.update_track_metadata/3","doc":"","ref":"Membrane.RTC.Engine.Endpoint.html#update_track_metadata/3"},{"type":"type","title":"Membrane.RTC.Engine.Endpoint.id/0","doc":"","ref":"Membrane.RTC.Engine.Endpoint.html#t:id/0"},{"type":"type","title":"Membrane.RTC.Engine.Endpoint.t/0","doc":"Module representing RTC Engine's endpoint.\n\nThis module contains:\n* `id` - id of the endpoint.\n* `type` - type of the endpoint.\n* `metadata` - metadata of the endpoint, assigned when engine receives `{:ready, metadata}` message from the endpoint.\n* `inbound_tracks` - inbound tracks (received by the endpoint from \"outside\" of the engine) of the endpoint.","ref":"Membrane.RTC.Engine.Endpoint.html#t:t/0"},{"type":"type","title":"Membrane.RTC.Engine.Endpoint.type/0","doc":"","ref":"Membrane.RTC.Engine.Endpoint.html#t:type/0"},{"type":"module","title":"Membrane.RTC.Engine.Message","doc":"Module describing messages RTC Engine can emit.\n\nEach Message contains the PID of the Engine under `rtc_engine` field.\nThanks to it you can distinguish between the same messages but from different RTC Engine instances.","ref":"Membrane.RTC.Engine.Message.html"},{"type":"type","title":"Membrane.RTC.Engine.Message.t/0","doc":"","ref":"Membrane.RTC.Engine.Message.html#t:t/0"},{"type":"module","title":"Membrane.RTC.Engine.Notifications.TrackNotification","doc":"Struct describing a track notification sent to the instance of `Membrane.RTC.Engine` by Endpoints.\n\nTrackNotification command indicates that the engine should forward a notification about the specified track to all endpoints subscribed to that track.\n*Receivers can choose to ignore the notification*.\n\nThe same struct will appear in `handle_other/3` callback on the receiver side.","ref":"Membrane.RTC.Engine.Notifications.TrackNotification.html"},{"type":"module","title":"Publishing the notification - Membrane.RTC.Engine.Notifications.TrackNotification","doc":"Endpoint can publish a TrackNotification about any of the tracks it publishes, making the following pattern.\n```elixir\nnotification = %Membrane.RTC.Engine.Notifications.TrackNotification{\n  track_id: \"trackID_1\",\n  notification: :hello_world\n}\n\n{{:ok, notify: {:publish, notification}}, state}\n```","ref":"Membrane.RTC.Engine.Notifications.TrackNotification.html#module-publishing-the-notification"},{"type":"type","title":"Membrane.RTC.Engine.Notifications.TrackNotification.t/0","doc":"Type describing track notification struct\n\n- `track_id` - id of the track that this notification is about. This the id of the track that was assigned to the track when publishing it to the engine.\n- `notification` - payload of the notification. Can be anything","ref":"Membrane.RTC.Engine.Notifications.TrackNotification.html#t:t/0"},{"type":"module","title":"Membrane.RTC.Engine.Track","doc":"Module representing media track.\n\nMedia track is a single audio or video. Tracks that are related to each other\n(e.g. audio from microphone that corresponds to video from a web cam) can be grouped into the same stream by\nassigning each of them the same stream id.","ref":"Membrane.RTC.Engine.Track.html"},{"type":"function","title":"Membrane.RTC.Engine.Track.get_depayloader/1","doc":"Returns depayloader for given track.\n\nDepayloader can be used to unpack RTP stream i.e. get\ndata out of RTP packets.\n\nReturns Membrane child specification or `nil` if depayloader\ncouldn't be determined.","ref":"Membrane.RTC.Engine.Track.html#get_depayloader/1"},{"type":"function","title":"Examples - Membrane.RTC.Engine.Track.get_depayloader/1","doc":"@impl true\n    def handle_pad_added(Pad.ref(:input, track_id) = pad, _ctx, state) do\n      children = %{\n        {:track_receiver, track_id} => %TrackReceiver{\n          track: Map.fetch!(state.tracks, track_id),\n          initial_target_variant: :high\n        },\n        {:depayloader, track.id} => get_depayloader(track),\n        {:serializer, track_id} => Membrane.Stream.Serializer,\n        {:sink, track_id} => %Membrane.File.Sink{\n          location: Path.join(state.output_dir_path, track_id)\n        }\n      }\n\n      links = [\n        link_bin_input(pad)\n        |> to({:track_receiver, track_id})\n        |> to({:depayloader, track.id})\n        |> to({:serializer, track_id})\n        |> to({:sink, track_id})\n      ]\n\n      {{:ok, spec: %ParentSpec{children: children, links: links}}, state}\n    end","ref":"Membrane.RTC.Engine.Track.html#get_depayloader/1-examples"},{"type":"function","title":"Membrane.RTC.Engine.Track.is_simulcast?/1","doc":"Checks whether track is a simulcast one or not.","ref":"Membrane.RTC.Engine.Track.html#is_simulcast?/1"},{"type":"function","title":"Membrane.RTC.Engine.Track.new/7","doc":"Creates a new track.\n\nTracks belonging to the same stream should have the same `stream_id`,\nthat can be generated with `stream_id/0`.","ref":"Membrane.RTC.Engine.Track.html#new/7"},{"type":"function","title":"Membrane.RTC.Engine.Track.stream_id/0","doc":"Generates stream id, that can be used to mark tracks belonging to the same stream.","ref":"Membrane.RTC.Engine.Track.html#stream_id/0"},{"type":"function","title":"Membrane.RTC.Engine.Track.supported_variants/0","doc":"Returns list of supported track variants.","ref":"Membrane.RTC.Engine.Track.html#supported_variants/0"},{"type":"type","title":"Membrane.RTC.Engine.Track.encoding/0","doc":"","ref":"Membrane.RTC.Engine.Track.html#t:encoding/0"},{"type":"type","title":"Membrane.RTC.Engine.Track.framerate/0","doc":"","ref":"Membrane.RTC.Engine.Track.html#t:framerate/0"},{"type":"type","title":"Membrane.RTC.Engine.Track.id/0","doc":"","ref":"Membrane.RTC.Engine.Track.html#t:id/0"},{"type":"type","title":"Membrane.RTC.Engine.Track.opts_t/0","doc":"Options that can be passed to `new/7`.\n\nIf not provided:\n* `id` - will be generated\n* `active?` - true\n* `variants` - `[:high]`\n* `metadata` - `nil`\n* `ctx` - `%{}`\n\nFor more information refer to `t:t/0`.","ref":"Membrane.RTC.Engine.Track.html#t:opts_t/0"},{"type":"type","title":"Membrane.RTC.Engine.Track.t/0","doc":"This module contains:\n* `type` - audio or video,\n* `stream_id` - media stream this track belongs to. Relationship between tracks (e.g. audio and video)\ncan be indicated by assigning each of them the same `stream_id`. One `stream_id` can be assign to any\nnumber of tracks.\n* `id` - track id\n* `origin` - id of Endpoint this track belongs to\n* `encoding` - track encoding\n* `variants` - list of possible track variants. Refer to `t:variant/0`.\n* `clock_rate` - track clock rate\n* `fmtp` - struct describing format specific parameters e.g. for H264 it contains `profile_level_id`\n* `active?` - indicates whether track is still available or not (because client left a room)\n* `metadata` - any data passed by user to be linked with this track\n* `ctx` - any data Endpoints need to associate with `Membrane.RTC.Engine.Track.t()` for internal usage\n* `framerate` - track framerate.  It's up to endpoints whether they set this field or not but if they do, they should only set it for video tracks with constant framerate. For audio tracks, framerate should always be `nil`. Defaults to `nil`.","ref":"Membrane.RTC.Engine.Track.html#t:t/0"},{"type":"type","title":"Membrane.RTC.Engine.Track.variant/0","doc":"Possible track variants.\n\nThe usage should be as follows:\n* `:high` - main track variant\n* `:medium` -  lower (in terms of quality) track variant\n* `:low` - the lowest track variant\n\nAudio tracks can have only one variant - `:high`.","ref":"Membrane.RTC.Engine.Track.html#t:variant/0"},{"type":"module","title":"Membrane.RTC.Engine.Track.BitrateEstimation","doc":"Struct describing bitrate estimation.","ref":"Membrane.RTC.Engine.Track.BitrateEstimation.html"},{"type":"type","title":"Membrane.RTC.Engine.Track.BitrateEstimation.t/0","doc":"Type describing bitrate estimation:\n- estimation - estimated bitrate in kbps\n- error - expected error of the estimation","ref":"Membrane.RTC.Engine.Track.BitrateEstimation.html#t:t/0"},{"type":"module","title":"Membrane.RTC.Engine.Event.RequestTrackVariant","doc":"Event for changing track variant that is currently being received.\n\nSending this event will cause the engine to send a keyframe request\nevent to the track origin. Once the engine receives a keyframe\nfor the requested track variant, it will start forwarding it to\nthe requester.\n\nIf the requested track variant becomes inactive before being delivered\nit has to be re-requested when it becomes active again.\n\nSee also `Membrane.RTC.Engine.Event.TrackVariantSwitched`.","ref":"Membrane.RTC.Engine.Event.RequestTrackVariant.html"},{"type":"type","title":"Membrane.RTC.Engine.Event.RequestTrackVariant.t/0","doc":"Type describing RequestTrackVariant event.\n\n* `variant` - track variant to receive\n* `reason` - reason of the request. It will be repeated in\n`Membrane.RTC.Engine.Event.TrackVariantSwitched`. Defaults to `nil`.","ref":"Membrane.RTC.Engine.Event.RequestTrackVariant.html#t:t/0"},{"type":"module","title":"Membrane.RTC.Engine.Event.TrackVariantBitrate","doc":"Event indicating bitrate of the track's variant.","ref":"Membrane.RTC.Engine.Event.TrackVariantBitrate.html"},{"type":"type","title":"Membrane.RTC.Engine.Event.TrackVariantBitrate.t/0","doc":"Type describing TrackVariantBitrate event.","ref":"Membrane.RTC.Engine.Event.TrackVariantBitrate.html#t:t/0"},{"type":"module","title":"Membrane.RTC.Engine.Event.TrackVariantPaused","doc":"Event sent whenever track variant was paused.","ref":"Membrane.RTC.Engine.Event.TrackVariantPaused.html"},{"type":"type","title":"Membrane.RTC.Engine.Event.TrackVariantPaused.t/0","doc":"Type describing TrackVariantPaused event.","ref":"Membrane.RTC.Engine.Event.TrackVariantPaused.html#t:t/0"},{"type":"module","title":"Membrane.RTC.Engine.Event.TrackVariantResumed","doc":"Event sent whenever track variant was resumed.","ref":"Membrane.RTC.Engine.Event.TrackVariantResumed.html"},{"type":"type","title":"Membrane.RTC.Engine.Event.TrackVariantResumed.t/0","doc":"Type describing TrackVariantResumed event.","ref":"Membrane.RTC.Engine.Event.TrackVariantResumed.html#t:t/0"},{"type":"module","title":"Membrane.RTC.Engine.Event.TrackVariantSwitched","doc":"Event sent whenever Engine starts sending a new track variant.\n\nSee also `Membrane.RTC.Engine.Event.RequestTrackVariant`.","ref":"Membrane.RTC.Engine.Event.TrackVariantSwitched.html"},{"type":"type","title":"Membrane.RTC.Engine.Event.TrackVariantSwitched.t/0","doc":"Type describing TrackVariantSwitched event.\n\n* `new_variant` - variant that engine will be sending from now\n* `reason` - a reason passed in `Membrane.RTC.Engine.Event.RequestTrackVariant`.\nDefaults to `nil`,","ref":"Membrane.RTC.Engine.Event.TrackVariantSwitched.html#t:t/0"},{"type":"module","title":"Membrane.RTC.Engine.Event.VoiceActivityChanged","doc":"An event indicating that the voice activity on the given track has changed.\n\nEndpoints should only emit those events when they implement voice activity detection.","ref":"Membrane.RTC.Engine.Event.VoiceActivityChanged.html"},{"type":"type","title":"Membrane.RTC.Engine.Event.VoiceActivityChanged.t/0","doc":"Type describing an event indicating changes in voice activity on the\ngiven audio track.","ref":"Membrane.RTC.Engine.Event.VoiceActivityChanged.html#t:t/0"},{"type":"module","title":"Membrane.RTC.Engine.Message.EndpointAdded","doc":"Message emitted when an endpoint gets added.","ref":"Membrane.RTC.Engine.Message.EndpointAdded.html"},{"type":"type","title":"Membrane.RTC.Engine.Message.EndpointAdded.t/0","doc":"Describes EndpointAdded message structure.\n\n* `endpoint_id` - id of the endpoint that was added\n* `endpoint_type` - type of the endpoint that was added","ref":"Membrane.RTC.Engine.Message.EndpointAdded.html#t:t/0"},{"type":"module","title":"Membrane.RTC.Engine.Message.EndpointCrashed","doc":"Message emitted when an endpoint crashes.","ref":"Membrane.RTC.Engine.Message.EndpointCrashed.html"},{"type":"type","title":"Membrane.RTC.Engine.Message.EndpointCrashed.t/0","doc":"Describes EndpointCrashed message structure.\n\n* `endpoint_id` - id of the endpoint that crashed\n* `endpoint_type` - type of the endpoint that crashed","ref":"Membrane.RTC.Engine.Message.EndpointCrashed.html#t:t/0"},{"type":"module","title":"Membrane.RTC.Engine.Message.EndpointMessage","doc":"Message emitted when an endpoint wishes to message the business logic.","ref":"Membrane.RTC.Engine.Message.EndpointMessage.html"},{"type":"type","title":"Membrane.RTC.Engine.Message.EndpointMessage.t/0","doc":"Describes EndpointMessage message structure\n\n* `endpoint_id` - id of the endpoint\n* `endpoint_type` - type of the endpoint\n* `message` - payload of the message sent by the endpoint","ref":"Membrane.RTC.Engine.Message.EndpointMessage.html#t:t/0"},{"type":"module","title":"Membrane.RTC.Engine.Message.EndpointRemoved","doc":"Message emitted when an endpoint gets removed.","ref":"Membrane.RTC.Engine.Message.EndpointRemoved.html"},{"type":"type","title":"Membrane.RTC.Engine.Message.EndpointRemoved.t/0","doc":"Describes EndpointRemoved message structure.\n\n* `endpoint_id` - id of the endpoint that was removed\n* `endpoint_type` - type of the endpoint that was removed","ref":"Membrane.RTC.Engine.Message.EndpointRemoved.html#t:t/0"},{"type":"module","title":"Membrane.RTC.Engine.Message.TrackAdded","doc":"Message emitted when a track gets added.","ref":"Membrane.RTC.Engine.Message.TrackAdded.html"},{"type":"type","title":"Membrane.RTC.Engine.Message.TrackAdded.t/0","doc":"Describes TrackAdded message structure.\n\n* `endpoint_id` - id of the endpoint that published the track\n* `endpoint_type` - type of the endpoint that published the track\n* `track_id` - id of the track that was added\n* `track_type` - type of the track that was added\n* `track_encoding` - encoding of the track that was added","ref":"Membrane.RTC.Engine.Message.TrackAdded.html#t:t/0"},{"type":"module","title":"Membrane.RTC.Engine.Message.TrackRemoved","doc":"Message emitted when a track gets removed.","ref":"Membrane.RTC.Engine.Message.TrackRemoved.html"},{"type":"type","title":"Membrane.RTC.Engine.Message.TrackRemoved.t/0","doc":"Describes TrackRemoved message structure.\n\n* `endpoint_id` - id of the endpoint that published the track\n* `endpoint_type` - type of the endpoint that published the track\n* `track_id` - id of the track that was removed\n* `track_type` - type of the track that was added\n* `track_encoding` - encoding of the track that was added","ref":"Membrane.RTC.Engine.Message.TrackRemoved.html#t:t/0"},{"type":"exception","title":"Membrane.RTC.Engine.Exception.PublishTrackError","doc":"","ref":"Membrane.RTC.Engine.Exception.PublishTrackError.html"},{"type":"exception","title":"Membrane.RTC.Engine.Exception.RequestTrackVariantError","doc":"","ref":"Membrane.RTC.Engine.Exception.RequestTrackVariantError.html"},{"type":"exception","title":"Membrane.RTC.Engine.Exception.TrackReadyError","doc":"","ref":"Membrane.RTC.Engine.Exception.TrackReadyError.html"},{"type":"exception","title":"Membrane.RTC.Engine.Exception.TrackVariantStateError","doc":"","ref":"Membrane.RTC.Engine.Exception.TrackVariantStateError.html"},{"type":"exception","title":"Membrane.RTC.Engine.Exception.VoiceActivityError","doc":"","ref":"Membrane.RTC.Engine.Exception.VoiceActivityError.html"},{"type":"extras","title":"Membrane RTC Engine","doc":"# Membrane RTC Engine\n\n[![Hex.pm](https://img.shields.io/hexpm/v/membrane_rtc_engine.svg)](https://hex.pm/packages/membrane_rtc_engine)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/membrane_rtc_engine)\n[![codecov](https://codecov.io/gh/jellyfish-dev/membrane_rtc_engine/branch/master/graph/badge.svg?token=9F1XHHUY2B)](https://codecov.io/gh/jellyfish-dev/membrane_rtc_engine)\n[![CircleCI](https://circleci.com/gh/jellyfish-dev/membrane_rtc_engine.svg?style=svg)](https://circleci.com/gh/jellyfish-dev/membrane_rtc_engine)\n\nCustomizable Real-time Communication Engine/SFU library focused on WebRTC.","ref":"readme.html"},{"type":"extras","title":"Installation - Membrane RTC Engine","doc":"The package can be installed by adding `membrane_rtc_engine` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:membrane_rtc_engine, \"~> 0.19.0\"}\n  ]\nend\n```\n\nTo use a given Endpoint, you have to include it in your list of dependencies as well:\n```elixir\ndef deps do\n  [\n    {:membrane_rtc_engine, \"~> 0.19.0\"},\n    {:membrane_rtc_engine_webrtc, \"~> 0.5.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Membrane RTC Engine","doc":"For usage examples, please refer to our [membrane_demo](https://github.com/membraneframework/membrane_demo/tree/master/webrtc_videoroom) or\n[membrane_videoroom](https://github.com/membraneframework/membrane_videoroom) repositories.","ref":"readme.html#usage"},{"type":"extras","title":"Developing - Membrane RTC Engine","doc":"To make development a little easier, we have added several tasks:\n- `mix test.all`, which runs unit tests from the engine, unit tests from each endpoint, and\n  endpoint integration tests,\n- `mix test.webrtc.integration`, which runs WebRTC Endpoint integration tests\n  (present [here](https://github.com/jellyfish-dev/membrane_rtc_engine/tree/master/webrtc/integration_test/test_videoroom)).\n- To test a given Endpoint, you can use the following aliases: `mix test.webrtc`,\n  `mix test.hls`, `mix test.rtsp`, `mix test.file` and `mix test.integration`.","ref":"readme.html#developing"},{"type":"extras","title":"Copyright and License - Membrane RTC Engine","doc":"Copyright 2021, [Software Mansion](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane_rtc_engine)\n\n[![Software Mansion](https://logo.swmansion.com/logo?color=white&variant=desktop&width=200&tag=membrane-github)](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane_rtc_engine)\n\nLicensed under the [Apache License, Version 2.0](LICENSE)","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"0.19.0 - Changelog","doc":"* Discard messages from endpoints that are not marked as ready [#339](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/339)\n* Extend Engine.terminate API [#337](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/337)\n* Update to Membrane Core 1.0 [#331](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/331)\n* Add `get_tracks` function in `Engine` module [#328](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/328)\n* Change some logs to debug [#327](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/327)\n* Miniscule doc fix [#333](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/333)","ref":"changelog.html#0-19-0"},{"type":"extras","title":"0.18.0 - Changelog","doc":"* Modify `Track`, mix.exs and docs because of adding File Endpoint [#323](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/323)","ref":"changelog.html#0-18-0"},{"type":"extras","title":"0.17.1 - Changelog","doc":"* Bump deps [#318](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/318)\n* Add `get_active_tracks` function in `Endpoint` module [#317](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/317)","ref":"changelog.html#0-17-1"},{"type":"extras","title":"0.17.0 - Changelog","doc":"* Cleanup RTC Engine deps. Move metrics to the WebRTC Endpoint [#306](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/306)\n* Add `get_num_forwarded_tracks` function [#300](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/300)\n* Add new endpoint and track notifications [#310](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/310)\n* Update upgrading guide to use new repo paths [#311](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/311)","ref":"changelog.html#0-17-0"},{"type":"extras","title":"0.16.0 - Changelog","doc":"* Convert RTC Engine into monorepo [#298](https://github.com/jellyfish-dev/membrane_rtc_engine/pull/298)","ref":"changelog.html#0-16-0"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2021 Software Mansion\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"},{"type":"extras","title":"Track Lifecycle","doc":"# Track Lifecycle\n\nThere are two types of tracks - audio and video.\n\nVideo tracks might be in multiple qualities/resolutions.\nWe call them variants and indentify them using atoms - `:high`, `:medium`, `:low`.\n\nIn general:\n* `:high` - main track resolution\n* `:medium` - main track resolution scaled down by 2 \n* `:low` - main track resolution scaled down by 4 \n\nAudio tracks can have only one variant - `:high`.\n\nAt first, each track is created with `Membrane.RTC.Engine.Track.new/7`.\nIt is important that the engine supports only RTP tracks so each endpoint\nthat publishes some track has to publish it in the form of RTP packets.\n\n> ##","ref":"track_lifecycle.html"},{"type":"extras","title":"Unpacking RTP stream {: .tip} - Track Lifecycle","doc":"> If you are writing an endpoint that consumes data from the engine\n> you can get media out of RTP packets with the support of `Membrane.RTC.Engine.Track.get_depayloader/1`.\n\nAfter creating a track it is published using `t:Membrane.RTC.Engine.publish_action_t/0`.\nThis causes the engine to notify other endpoints about new tracks and allows other endpoints\nto subscribe to them.\n\nNext, each track variant is marked as ready with `t:Membrane.RTC.Engine.track_ready_action_t/0`.\nThe action informs the engine that it can link bin's output pad to the engine itself.\n\nAt this point, the track is published and marked as ready.\nNext section outlines how resuming, pausing and requesting track variants looks like.","ref":"track_lifecycle.html#unpacking-rtp-stream-tip"},{"type":"extras","title":"Managing track variants - Track Lifecycle","doc":"#","ref":"track_lifecycle.html#managing-track-variants"},{"type":"extras","title":"Resuming and pausing track variant - Track Lifecycle","doc":"```ascii\nEndpoint ---- TrackVariantResumed (:medium) ---> Engine\nEndpoint ----        media (:medium)        ---> Engine\nEndpoint ---- TrackVariantResumed (:low)    ---> Engine\nEndpoint ----        media (:low)           ---> Engine\nEndpoint ---- TrackVariantPaused (:medium)  ---> Engine\n``` \n\nGeneral rules:\n* media can flow only when a track variant is in the resumed state\n* when a track variant becomes inactive for some reason (e.g. browser stops sending it to the\nserver because of bandwidth limitation), such variant is marked as paused with\n`Membrane.RTC.Engine.Event.TrackVariantPaused`.\n\n\n#","ref":"track_lifecycle.html#resuming-and-pausing-track-variant"},{"type":"extras","title":"Requesting track variant - Track Lifecycle","doc":"```ascii\nEngine ---- TrackVariantResumed (:medium) ---> Endpoint\nEngine <--- RequestTrackVariant (:medium) ---- Endpoint\nEngine ---- TrackVariantResumed (:low)    ---> Endpoint\nEngine ---- TrackVariantSwitched          ---> Endpoint\nEngine ----        media                  ---> Endpoint\nEngine ---- TrackVariantPaused  (:medium) ---> Endpoint\nEngine <--- RequestTrackVariant (:low)    ---- Endpoint\n``` \n\nGeneral rules:\n* after requesting a track variant but before receiving the\nvery first media packets, there is always the \n`Membrane.RTC.Engine.Event.TrackVariantSwitched` event.\n* if requested track variant becomes inactive before being delivered,\nit has to be re-requested once it becomes active again\n* sending the `Membrane.RTC.Engine.Event.RequestTrackVariant` event \ncauses engine to send the `Membrane.KeyframeRequestEvent` event to the track origin.\nOnce engine receives a keyframe from the publisher it will start forwarding \nrequested track.","ref":"track_lifecycle.html#requesting-track-variant"},{"type":"extras","title":"Custom endpoint","doc":"# Custom endpoint\n\nThis section outlines how to implement a custom RTC Engine endpoint that\nsaves tracks published by the WebRTC endpoint.\n\n> ##","ref":"custom_endpoints.html"},{"type":"extras","title":"Before you continue {: .tip} - Custom endpoint","doc":"> It is recommended to read [Track Lifecycle](guides/track_lifecycle.md) section before\n> diving deeper in this guide.\n> You will also find there some information about publishing a track.\n\n> ##","ref":"custom_endpoints.html#before-you-continue-tip"},{"type":"extras","title":"HLS endpoint {: .tip} - Custom endpoint","doc":"> Another endpoint that saves WebRTC tracks and is shipped with the engine is [the HLS endpoint](https://hexdocs.pm/membrane_rtc_engine_hls/readme.html).","ref":"custom_endpoints.html#hls-endpoint-tip"},{"type":"extras","title":"General rules - Custom endpoint","doc":"Each RTC Engine endpoint has to:\n* implement `Membrane.Bin` behavior\n* have at least one Membrane element that will be responsible for producing or\nconsuming data as Membrane bins are used only for logical grouping - they\ndon't process data\n* publish or/and subscribe to tracks","ref":"custom_endpoints.html#general-rules"},{"type":"extras","title":"Implementing `Membrane.Bin` - Custom endpoint","doc":"To implement `Membrane.Bin` behavior we have to:\n* `use Membrane.Bin`\n* specify some configuration options (if needed)\n* specify input and/or output pads\n* implement some callbacks.\n\nPads definition depends on what our bin is intended to do.\nFor example, if our endpoint does not publish any tracks but only subscribes for tracks from other\nendpoints it can specify only input pads.\nPads should be in the following form\n\n```elixir\ndef_input_pad :input,\n    demand_unit: :buffers,\n    stream_format: Membrane.RTP,\n    availability: :on_request\n\ndef_output_pad :output,\n    demand_unit: :buffers,\n    stream_format: Membrane.RTP,\n    availability: :on_request\n```\n\nWhen it comes to endpoint options we will have:\n* `rtc_engine` - pid of RTC engine. It will be used for subscribing for a track\n* `output_dir_path` - output directory path i.e. where our tracks should be saved.\n\nPutting it all together we have\n\n```elixir\ndefmodule RecordingEndpoint do\n  @moduledoc \"\"\"\n  Endpoint for saving tracks to a disk.\n\n  Each track will be saved in a separate file.\n  \"\"\"\n  use Membrane.Bin\n\n  alias Membrane.RTC.Engine\n\n  def_options rtc_engine: [\n                spec: pid(),\n                description: \"Pid of parent Engine\"\n              ],\n              output_dir_path: [\n                spec: Path.t(),\n                description: \"Path to directory, where tracks will be saved.\"\n              ]\n\n  def_input_pad :input,\n    demand_unit: :buffers,\n    accepted_format: _any,\n    availability: :on_request\n\n  @impl true\n  def handle_init(_ctx, opts) do\n    state = %{\n      output_dir_path: opts.output_dir_path,\n      rtc_engine: opts.rtc_engine,\n    }\n\n    {[], state}\n  end\nend\n```","ref":"custom_endpoints.html#implementing-membrane-bin"},{"type":"extras","title":"Consuming data - Custom endpoint","doc":"Because `Membrane.Bin`s are not capable of sending or consuming any data on their own\n(they can be more thought of as logical containers) we have to add at least one\ncasual Membrane element that will do this for us.\n\nIn our case, we will need three elements:\n* `Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver` - responsible for requesting the highest\npossible track variant and switching to other variants when the currently used one becomes inactive\n* [`Membrane.Stream.Serializer`](https://hexdocs.pm/membrane_stream_plugin/Membrane.Stream.Serializer.html) -\nused for serializing incoming Membrane stream\n* `Membrane.File.Sink` - used for saving serialized data into a file\n\nFor each incoming track we will create separate serializer and sink.","ref":"custom_endpoints.html#consuming-data"},{"type":"extras","title":"Subscribing to a track - Custom endpoint","doc":"Whenever some endpoint publishes its tracks, all other endpoints receive a message\nin form of `{:new_tracks, tracks}` where `tracks` is a list of `t:Membrane.RTC.Engine.Track.t/0`.\n\nTo subscribe to any of the published tracks, an endpoint has to call `Membrane.RTC.Engine.subscribe/4`.\n\nAfter subscribing to a track, the endpoint will be notified about its readiness in\n`c:Membrane.Bin.handle_pad_added/3` callback. An example implementation of `handle_pad_added`\ncallback can look like this\n\n```elixir\n@impl true\ndef handle_pad_added(Pad.ref(:input, track_id) = pad, _ctx, state) do\n  spec = [\n    bin_input(pad)\n    |> child({:track_receiver, track_id}, %TrackReceiver{\n      track: Map.fetch!(state.tracks, track_id),\n      initial_target_variant: :high\n    })\n    |> child({:serializer, track_id}, Membrane.Stream.Serializer)\n    |> child({:sink, track_id}, %Membrane.File.Sink{\n      location: Path.join(state.output_dir_path, track_id)\n    })\n  ]\n\n  {[spec: spec], state}\nend\n```\n\nWe simply link our input pad on which we will receive media data to the track receiver,\nserializer and then to the sink.\n\nThe endpoint will be also notified when some tracks it subscribed to are removed with\n`{:removed_tracks, tracks}` message.\n\n> ##","ref":"custom_endpoints.html#subscribing-to-a-track"},{"type":"extras","title":"Deeper dive into TrackReciver {: .tip} - Custom endpoint","doc":">\n> After linking the input pad for a given track, our endpoint will start receiving events.\n> The very first event is always `TrackVariantResumed`. It informs that a given track\n> variant is available and can be requested with the `RequestTrackVariant` event.\n> The engine ensures that each endpoint always receives a track variant starting from\n> a keyframe, so before receiving the first media packets our endpoint\n> will receive the `TrackVariantSwitched` event and finally media packets will\n> start flowing.\n>\n> When some track variant is paused, the endpoint will receive the `TrackVariantPaused` event.\n>\n> The whole process is shown in the following diagram\n>\n> ```ascii\n> Engine ---- TrackVariantResumed (:medium) ---> Endpoint\n> Engine <--- RequestTrackVariant (:medium) ---- Endpoint\n> Engine ---- TrackVariantResumed (:low)    ---> Endpoint\n> Engine ---- TrackVariantSwitched          ---> Endpoint\n> Engine ----        media                  ---> Endpoint\n> Engine ---- TrackVariantPaused  (:medium) ---> Endpoint\n> Engine <--- RequestTrackVariant (:low)    ---- Endpoint\n> ```\n>\n> Because this logic must be duplicated in each endpoint we encapsulated\n> it into `TrackReceiver` that can easily be plugged in before the actual\n> Membrane element.\n>\n\nPutting it all together\n\n```elixir\ndefmodule RecordingEndpoint do\n  @moduledoc \"\"\"\n  Endpoint for saving tracks to a disk.\n\n  Each track will be saved in a separate file.\n  \"\"\"\n  use Membrane.Bin\n\n  require Membrane.Logger\n\n  alias Membrane.RTC.Engine\n  alias Membrane.RTC.Engine.Endpoint.WebRTC.TrackReceiver\n\n  def_options rtc_engine: [\n                spec: pid(),\n                description: \"Pid of parent Engine\"\n              ],\n              output_dir_path: [\n                spec: Path.t(),\n                description: \"Path to directory, where tracks will be saved.\"\n              ]\n\n  def_input_pad :input,\n    demand_unit: :buffers,\n    accepted_format: _any,\n    availability: :on_request\n\n  @impl true\n  def handle_init(_ctx, opts) do\n    state = %{\n      output_dir_path: opts.output_dir_path,\n      rtc_engine: opts.rtc_engine,\n      tracks: %{}\n    }\n\n    {[], state}\n  end\n\n  @impl true\n  def handle_pad_added(Pad.ref(:input, track_id) = pad, _ctx, state) do\n    spec = [\n      bin_input(pad)\n      |> child({:track_receiver, track_id}, %TrackReceiver{\n        track: Map.fetch!(state.tracks, track_id),\n        initial_target_variant: :high\n      })\n      |> child({:serializer, track_id}, Membrane.Stream.Serializer)\n      |> child({:sink, track_id}, %Membrane.File.Sink{\n        location: Path.join(state.output_dir_path, track_id)\n      })\n    ]\n\n    {[spec: spec], state}\n  end\n\n  @impl true\n  def handle_pad_removed(Pad.ref(:input, track_id), _ctx, state) do\n    children = [\n      {:track_receiver, track_id},\n      {:serializer, track_id},\n      {:sink, track_id}\n    ]\n\n    {[remove_children: children], state}\n  end\n\n  @impl true\n  def handle_parent_notification({:new_tracks, tracks}, ctx, state) do\n    {:endpoint, endpoint_id} = ctx.name\n\n    Enum.reduce_while(tracks, {[], state}, fn track, {[], state} ->\n      case Engine.subscribe(state.rtc_engine, endpoint_id, track.id) do\n        :ok ->\n          {:cont, {[], update_in(state, [:tracks], &Map.put(&1, track.id, track))}}\n\n        {:error, :invalid_track_id} ->\n          Membrane.Logger.warn(\"\"\"\n          Couldn't subscribe to the track: #{inspect(track.id)}. No such track.\n          It had to be removed just after publishing it. Ignoring.\n          \"\"\")\n\n          {:cont, {[], state}}\n\n        {:error, reason} ->\n          raise \"Couldn't subscribe to the track: #{inspect(track.id)}. Reason: #{inspect(reason)}\"\n      end\n    end)\n  end\n\n  @impl true\n  def handle_parent_notification({:remove_tracks, _tracks}, _ctx, state) do\n    {[], state}\n  end\n\n  @impl true\n  def handle_parent_notification(_msg, _ctx, state) do\n    # ignore all other notifications\n    {[], state}\n  end\nend\n```","ref":"custom_endpoints.html#deeper-dive-into-trackreciver-tip"},{"type":"extras","title":"Logs","doc":"# Logs\n\nRTC Engine and its endpoints add following metadata to logs:\n* rtc_engine - RTC Engine id passed to `Membrane.RTC.Engine.start_link/2` or `Membrane.RTC.Engine.start/2`\n* webrtc_endpoint - WebRTC endpoint id passed as endpoint_id to `Membrane.RTC.Engine.add_endpoint/3`\n\nMetadata has to be turned on in config files with\n\n```elixir\nconfig :logger, :console, metadata: [:rtc_engine, :webrtc_endpoint]\n```\n\nAdditionaly, some endpoints might accept their own log metadata e.g.\n\n```elixir\nendpoint = %WebRTC{\n  log_metadata: [some_additional_metadata: \"some_additional_metadata\"],\n}\n```","ref":"logs.html"},{"type":"extras","title":"Traces","doc":"# Traces\n\nRTC Engine uses [`membrane_opentelemetry`](https://github.com/membraneframework/membrane_opentelemetry) to generate OpenTelemetry traces and spans.\nYou can enable traces in your `config.exs`:\n```elixir\nconfig :membrane_opentelemetry, enabled: true\n```\nBesides this you need to put `:opentelemetry` config in `config/runtime.exs`, for example\n```elixir\nconfig :opentelemetry, :resource,\n  service: [\n    name: \"membrane_rtc_engine\",\n    namespace: \"membrane\"\n  ],\n  processors: [\n    otel_batch_processor: %{\n      exporter: {:otel_exporter_stdout, []}\n    }\n  ]\n```\nWhere:\n  * `service` - name and namespace of the service. They are used for easier distinction from other services. You can read more [here](https://opentelemetry.io/docs/reference/specification/resource/semantic_conventions/#service)\n  * `processors` - defines when spans should be exported. `otel_simple_procesor` flushes each span immediately after ending it while `otel_batch_processor` buffers several spans and flushes them in a batch. For more see [otel_simple_processor](https://hexdocs.pm/opentelemetry/otel_simple_processor.html) or [otel_batch_processor](https://hexdocs.pm/opentelemetry/otel_batch_processor.html)\n  * `exporter` - defines where spans should be exported. otel_exporter_stdout prints spans to stdout but there are other exporters that can visualize traces in a human readable format like [Zipkin](https://github.com/open-telemetry/opentelemetry-erlang/tree/main/apps/opentelemetry_zipkin)\n\nTo see more about `:opentelemetry` config, you can go to the OpenTelemetry [documentation](https://opentelemetry.io/docs/instrumentation/erlang/getting-started/#initialization-and-configuration)\n\nYou can also go to [`membrane_videoroom`](https://github.com/membraneframework/membrane_videoroom) for more examples.","ref":"traces.html"},{"type":"extras","title":"Voice Activity Detection","doc":"# Voice Activity Detection\nVoice Activity Detection (VAD) is a feature available in Membrane RTC Engine that allows you to receive notifications about voice activity.\nYou may also know it as speech detection.\n\nAfter enabling this feature, you're going to start receiving `vadNotification` media events in your client application.\nThese media events contain a `trackId` and `vadStatus` - either speech or silence.\n\nDepending on the SDK, a callback or other means of publishing this information may be available.\nPlease refer to the documentation of your SDK.","ref":"vad.html"},{"type":"extras","title":"Enabling VAD - Voice Activity Detection","doc":"To enable VAD you need to\n1. Enable VAD RTP header extension\n2. Enable VAD WebRTC extension\n\nIn practice, ensure that:\n1. `Membrane.WebRTC.Extension.VAD` is present in the `webrtc_extensions` key of your WebRTC Endpoint configuration\n2. The following is part of the `extensions` key in your WebRTC Endpoint configuration\n```elixir\n%{\n  opus: Membrane.RTP.VAD\n}\n```","ref":"vad.html#enabling-vad"},{"type":"extras","title":"Upgrading to v0.14","doc":"# Upgrading to v0.14\n\nVersion 0.14 removes the concept of peers from the RTC Engine meaning that RTC Engine\nonly operates on Endpoints.\n\nIn practice, most changes come down to updating callback names.\n\nBelow, there are two PRs that update RTC Engine to the v0.14 in our demos:\n* https://github.com/membraneframework/membrane_videoroom/pull/178/files\n* https://github.com/membraneframework-labs/membrane_live/pull/187","ref":"v0-14.html"},{"type":"extras","title":"RTC Engine (Elixir) - Upgrading to v0.14","doc":"Instead of `peer_id` or `endpoint_id` use `id`:\n\n```diff\n- :ok = Engine.add_endpoint(state.rtc_engine, endpoint, peer_id: peer_id, node: peer_node)\n+ :ok = Engine.add_endpoint(state.rtc_engine, endpoint, id: peer_id, node: peer_node)\n```","ref":"v0-14.html#rtc-engine-elixir"},{"type":"extras","title":"SDK (JS) - Upgrading to v0.14","doc":"`MembraneWebRTC` class was renamed to `WebRTCEndpoint`.\nIt also no longer takes callbacks in the constructor.\nInstead, you have to subscribe for events:\n\n```diff\n- const webrtc = new MembraneWebRTC({callbacks: {}})\n+ const webrtc = new WebRTCEndpoint();\n```\n\n| callback | event |\n| --- | --- |\n| onSendMediaEvent | webrtc.on(\"sendMediaEvent\") |\n| onConnectionError | webrtc.on(\"connectionError\") |\n| onJoinSuccess | webrtc.on(\"connected\") |\n| onTrackReady | webrtc.on(\"trackReady\") |\n| onTrackAdded | webrtc.on(\"trackAdded\") |\n| onTrackRemoved | webrtc.on(\"trackRemoved\") |\n| onPeerJoined | webrtc.on(\"endpointAdded\") |\n| onPeerLeft | webrtc.on(\"endpointRemoved\") |\n| onTrackUpdated | webrtc.on(\"trackUpdated\") |\n| onTrackEncodingChanged | trackCtx.on(\"encodingChanged\") |\n| onJoinError | removed |\n\n\nThe process of \"connecting\" SDK to the RTC Engine endpoint is all about sending\na single message indicating SDK readiness.\nTherefore, instead of using `onJoinError`, a user is expected to observe its transport status (in most cases WS connection)\nand can add tracks as soon as `connect` function has been called.\n\nIt's important that `endpointAdded` event will be emitted for every endpoint added to the engine.\nYou can filter out endpoints by their type i.e.\n\n```ts\nwebrtc.on(\"endpointAdded\", (endpoint: Endpoint) => {\n   if (endpoint.type === \"webrtc\") {\n    // do something\n   }\n});\n```\n\n#","ref":"v0-14.html#sdk-js"},{"type":"extras","title":"Connecting - Upgrading to v0.14","doc":"```diff\n- webrtc.join(peerMetadata);\n+ webrtc.connect(metadata);\n```\n\n#","ref":"v0-14.html#connecting"},{"type":"extras","title":"Leaving - Upgrading to v0.14","doc":"```diff\n- webrtc.leave();\n+ webrtc.disconnect();\n```","ref":"v0-14.html#leaving"},{"type":"extras","title":"Upgrading to v0.16","doc":"# Upgrading to v0.16\n\nVersion 0.16 extracts the existing Endpoints to separate packages. This is to improve user\nexperience and remove the need to include numerous dependencies in your `mix.exs` if you want to use\na certain Endpoint.\n\nIn practice, the changes come down to updating the dependencies in your `mix.exs`.\n\nBelow, there are two PRs that update RTC Engine to v0.16 in our demos:\n* https://github.com/membraneframework/membrane_videoroom/pull/188\n* https://github.com/membraneframework-labs/membrane_live/pull/190","ref":"v0-16.html"},{"type":"extras","title":"RTC Engine and Endpoints (Elixir) - Upgrading to v0.16","doc":"In your `mix.exs`, in `deps`, you now need to include the appropriate package\nfor each Endpoint you use (as well as the Engine).\n\nThe good part is, you can get rid of all the dependencies tied to certain Endpoints! These\ndependencies used to be marked as `optional` in the Engine - now, they have been moved to the\nappropriate endpoint package.\n\n* If you're using the WebRTC Endpoint:\n\n```diff\n  defp deps do\n    [\n-     {:membrane_rtc_engine, \"~> 0.15.0\"}\n+     {:membrane_rtc_engine, \"~> 0.16.0\"},\n+     {:membrane_rtc_engine_webrtc, \"~> 0.1.0\"}\n    ]\n  end\n```\n\n* If you're using the HLS Endpoint:\n\n```diff\n  defp deps do\n    [\n-     :membrane_h264_ffmpeg_plugin,\n-     :membrane_h264_plugin,\n-     :membrane_http_adaptive_stream_plugin,\n-     :membrane_opus_plugin,\n-     :membrane_aac_plugin,\n-     :membrane_aac_fdk_plugin,\n-     {:membrane_rtc_engine, \"~> 0.15.0\"}\n+     {:membrane_rtc_engine, \"~> 0.16.0\"},\n+     {:membrane_rtc_engine_hls, \"~> 0.1.0\"}\n    ]\n  end\n```\n\nKeep in mind, though, if you're using either the Audio Mixer or the Video Compositor in the HLS Endpoint,\nyou still need to include the two mixer plugins in your `deps`:\n\n```diff\n  defp deps do\n    [\n-     :membrane_h264_ffmpeg_plugin,\n-     :membrane_h264_plugin,\n-     :membrane_http_adaptive_stream_plugin,\n-     :membrane_opus_plugin,\n-     :membrane_aac_plugin,\n-     :membrane_aac_fdk_plugin,\n      :membrane_video_compositor_plugin,\n      :membrane_audio_mix_plugin,\n-     {:membrane_rtc_engine, \"~> 0.15.0\"}\n+     {:membrane_rtc_engine, \"~> 0.16.0\"},\n+     {:membrane_rtc_engine_hls, \"~> 0.1.0\"}\n    ]\n  end\n```\n\n* If you're using the RTSP Endpoint:\n\n```diff\n  defp deps do\n    [\n-     :connection,\n-     :membrane_rtsp,\n-     :membrane_udp_plugin,\n-     {:membrane_rtc_engine, \"~> 0.15.0\"}\n+     {:membrane_rtc_engine, \"~> 0.16.0\"},\n+     {:membrane_rtc_engine_rtsp, \"~> 0.1.0\"}\n    ]\n  end\n```\n\n* If you're using two (or more) different Endpoints, simply add each needed package to the `deps` list.\n\nThe module names remain the same, so you don't need to change anything in your source files.","ref":"v0-16.html#rtc-engine-and-endpoints-elixir"},{"type":"extras","title":"Developing the Engine and Endpoints - Upgrading to v0.16","doc":"Version 0.16 converts the `membrane_rtc_engine` GitHub repository to a monorepo.\n\nFor development purposes, it is easiest to clone the entire repository and work locally, including\nthe Engine and needed Endpoints using local paths:\n\n```elixir\ndefp deps do\n  [\n    {:membrane_rtc_engine, path: \"/path/to/cloned/repository/engine/\"},\n    {:membrane_rtc_engine_webrtc, path: \"/path/to/cloned/repository/webrtc/\"},\n  ]\nend\n```\n\nAlternatively, you can use a sparse checkout:\n\n```elixir\ndefp deps do\n  [\n    {:membrane_rtc_engine, github: \"jellyfish-dev/membrane_rtc_engine\", sparse: \"engine\", override: true},\n    {:membrane_rtc_engine_webrtc, github: \"jellyfish-dev/membrane_rtc_engine\", sparse: \"webrtc\"},\n  ]\nend\n```\n\nIf you get any Mix errors, try adding the `override: true` option to packages which others depend\nupon (e.g. to the `membrane_rtc_engine` package if also using `membrane_rtc_engine_webrtc`).","ref":"v0-16.html#developing-the-engine-and-endpoints"},{"type":"extras","title":"Engine Architecture","doc":"# Engine Architecture\n\nThe RTC Engine is responsible for forwarding tracks to proper endpoints.\n\nWe require tracks to be published in the form of RTP packets however, neither\nengine nor tee has fields that are RTP or WebRTC specific.\nProtocol-specific logic should be handled inside specific endpoints.\n\nThe assumption that the engine is protocol-agnostic greatly simplifies\nits architecture and code while the assumption that a track has to be published\nin the form of RTP packets allows us to put some WebRTC-specific fields inside\nthe track's struct.\n\nFor each track, there is a separate tee responsible for\nforwarding this track to all subscribed endpoints.\n\n![Alt text](assets/engine_architecture.svg)","ref":"internal_engine_architecture.html"}],"content_type":"text/markdown"}